(function(Pandora){
	var userAgent = navigator.userAgent,
		isAndroid = userAgent.toLowerCase().indexOf('android') >= 0,
		isIos = userAgent.toLowerCase().indexOf('iphone') >= 0 || userAgent.toLowerCase().indexOf('ipad') >= 0,
		isTouch = userAgent.toLowerCase().indexOf('android') >= 0 ||  userAgent.toLowerCase().indexOf('iphone') >= 0 || userAgent.toLowerCase().indexOf('ipad') >= 0;

	var _touchstart = (isTouch ? 'touchstart' : 'mousedown'), 
	_touchmove = (isTouch ? 'touchmove' : 'mousemove'), 
	_touchend = (isTouch ? 'touchend' : 'mouseup');
	
	Pandora.fn.dragMargin = function(option) {
		option = option || {};
		var t = this[0];
		
		Comment.jsLog('dragMargin '+!t);
		if(!t) {
			return;
		}
		
		var isdrag = false,
		direction = "none",
		position = {
			distX : 0,
			distY : 0,
			startX : 0,
			startY : 0,
			endX : 0,
			endY : 0
		},
		dragstart = function(event) {
			isdrag = true;
			var touch = isTouch ? event.changedTouches[0] : event;
			position.startX = touch.pageX;
			position.startY = touch.pageY;
			if(t.style.marginTop) {
				Comment.jsLog('dragstart'+',t.style.marginTop = '+t.style.marginTop);
				position.endY = parseInt(t.style.marginTop);
			}
			
			if(t.style.marginLeft) {
				Comment.jsLog('dragstart'+', t.style.marginLeft = '+t.style.marginLeft);
				position.endX = parseInt(t.style.marginLeft);
			}
			Comment.jsLog('dragstart'+',t.style.marginTop = '+t.style.marginTop+', t.style.marginLeft = '+t.style.marginLeft +', isdrag = '+isdrag+', direction = '+direction);
			option.start(event, position,t);

		}, 
		drag = function(event) {
			Comment.jsLog('drag' +', isdrag = '+isdrag);
			if(!isdrag) {
				return;
			}
			Comment.jsLog('drag ------' +', isdrag = '+!isdrag+', direction = '+direction);
			var touch = isTouch ? event.targetTouches[0] : event;
				position.distX = touch.pageX - position.startX + position.endX, 
				position.distY = touch.pageY - position.startY + position.endY;
			
			
			if(direction === "x"){
				event.preventDefault();
				t.style.marginLeft = position.distX + 'px';
				Comment.jsLog('drag x  t.style.marginLeft = '+t.style.marginLeft);
				option.drag(event, position,t);
			
			}else if(direction === "y"){
				Comment.jsLog('drag  y ');
				option.dragContentY(event, position,position.distY);
				
			}else if(direction === "none"){
				var ex = Math.abs(touch.pageX - position.startX),
					ey = Math.abs(touch.pageY - position.startY);
				if((ex > 8 || ey > 8) && ex > ey ){
					direction = "x";
				}else if((ex > 8 || ey > 8) && ex < ey){
					direction = "y";
				}
			}
			Comment.jsLog('drag end------' +', isdrag = '+isdrag+', direction = '+direction);
		},
		dragend = function(event) {
			Comment.jsLog('dragend' +', isdrag = '+isdrag+', direction = '+direction);
			if(direction == "x") {
				if(t.style.marginLeft) {
					position.endX = parseInt(t.style.marginLeft);
				}
				Comment.jsLog('dragend x');
				option.end(event, position,t);
				
			}
			if(direction == "y") {
				if(t.style.marginTop) {
					position.endY = parseInt(t.style.marginTop);
				}
				Comment.jsLog('dragend y');
				option.dragContentYend(event, position,position.distY);
				
			}
			direction = "none";
			isdrag = false;
			
			
		};
		
		t.addEventListener(_touchstart, dragstart, true);
		t.addEventListener(_touchmove, drag, true);
		t.addEventListener(_touchend, dragend, true);
	}
	
	Pandora.fn.draggableX = function(option) {
		option = option || {};
		var t = this[0];
		
		if(!t) {
			return;
		}
		
		var isdrag = false,
		position = {
			startX : 0,
			startY : 0,
			endX : 0,
			endY : 0
		},
		dragstart = function(event) {
			isdrag = true;
			var touch = isTouch ? event.changedTouches[0] : event;
			position.startX = touch.pageX;
			
			if(t.style.marginLeft) {
				position.endX = parseInt(t.style.marginLeft);
			}
			
			option.start(event, position,t);
			Comment.jsLog('dragstart'+',t.style.marginTop = '+t.style.marginTop+', t.style.marginLeft = '+t.style.marginLeft);
		}, 
		drag = function(event) {
			//document.getElementById("text").innerHTML = 'drag x <br />'+ document.getElementById("text").innerHTML;
			if(!isdrag) {
				return;
			}
			var touch = isTouch ? event.targetTouches[0] : event ,
				x = touch.pageX - position.startX + position.endX; 
			
			event.preventDefault();
			t.style.marginLeft = x + 'px';
			option.drag(event, position,t);
		
		},
		dragend = function(event) {
			isdrag = false;
			if(t.style.marginLeft) {
				position.endX = parseInt(t.style.marginLeft);
				//document.getElementById("text").innerHTML =  "if(t.style.marginLeft x) position.endX="+ position.endX + "<br />" + document.getElementById("text").innerHTML;
				//console.log("");
			}
			
			option.end(event, position,t);
		};
		
		t.addEventListener(_touchstart, dragstart, true);
		t.addEventListener(_touchmove, drag, true);
		t.addEventListener(_touchend, dragend, true);
	};
})($);
